////////////////
// Point class implementation
//

#include <stdio.h>
#include "point.h"

//////////////////
// print function calls getx and gety, but this alone is not enough
// to trigger their instantiation as real functions.
//
void Point::print()
{
	printf("Point(%d, %d)\n", getx(), gety());
}

//////////////////
// If this function is commented out, the compiler won't generate
// real functions for Point::getx and Point::gety in point.asm, 
// The compiler must instantiate getx and gety in order to initialize
// the vtable inside p.
//
void SomeFnThatCreatesAPoint()
{
	// Create a point on the stack. 
	// Note: could also do "new Point"
	Point p;
}
