// SHAPES.H: Fragment of a header file from a 
// hypothetical shapes library.

// Base class: generic shape with pure virtual fn to get area
//
class Shape {
public: 
	virtual float area() = 0;
};

// Rectangle: area is width times height
//
class Rectangle : public Shape {
	float width, height;
public: 
	float area() { return width * height; }
};

// Circle: area is pi times radius squared
//
const float PI = 3.14159;
class Circle : public Shape {
	float radius;
public: 
	float area() { return PI * radius * radius; }
};

// A region is just a list of shapes.
// The Actual implementation is unimportant.
//
class Region : public Shape {
	Shape *firstShape();
	Shape *nextShape();
public:
	float area();
};

