////////////////////////////////////////////////////////////////
// VINLINE.CPP. Sample program showing how inline 
// virtual functions get expanded, if at all.

//////////////////
// Some class with a virtual function
//
class Foo {
public:
	virtual int get17()	
		{ return 17; }
};

int main(int, char**)
{
	// First, call get17 through stack instance.
	// Compiler "knows" that f is really a Foo.
	Foo f;
	int i = f.get17();

	// Now call get17 through pointer to Foo object. The compiler doesn't
	// know that pf is really a pointer to a Foo object, because you might
	// assign pf to some other object of some other class derived from Foo.
	Foo *pf;
	pf = new Foo;
	int j = pf->get17();
	delete pf;

	return 0;
}
